﻿/*****************************************************************
 * Jackson Fields
 * SpriteFontHelper.cs
 * ***************************************************************/

using System;
using System.Collections.Generic;
using System.Linq;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Media;

namespace Engine
{
    public static class SpriteFontHelper
    {
        public static void DrawCenteredText(SpriteBatch sb, SpriteFont spriteFont, String text, Vector2 position, Color color)
        {
            Vector2 textSize = spriteFont.MeasureString(text);

            sb.DrawString(spriteFont, text, position - textSize / 2, color);
        }
    }
}
