﻿//using System;
//using System.Collections.Generic;
//using System.Linq;
//using Microsoft.Xna.Framework;
//using Microsoft.Xna.Framework.Audio;
//using Microsoft.Xna.Framework.Content;
//using Microsoft.Xna.Framework.GamerServices;
//using Microsoft.Xna.Framework.Graphics;
//using Microsoft.Xna.Framework.Input;
//using Microsoft.Xna.Framework.Media;
//using Engine;

//namespace kinectApp
//{
//    //TODO: read from XML
//    public class NotPineTree : TreeRules
//    {
//        Game1 game;

//        public NotPineTree(Game1 game)
//            : base()
//        {
//            this.game = game;
//        }

//        private int numPointsOnLobe = 30;

//        private int angle = 45; //angle of branches
//        private int angleVariation = 0;

//        private int trunkAngle = 45;

//        public  int TrunkAngle()
//        {
//            return trunkAngle;
//        }

//        private float leafTaper = 0;

//        public  float LeafTaper()
//        {
//            return leafTaper;
//        }

//        private int numIterations = 2;

//        public  int NumIterations()
//        {
//            return numIterations;
//        }

//        public int BranchIterations()
//        {
//            return 2;
//        }

//        private int subsequentAngle = 15;

//        public  int SubsequentAngle()
//        {
//            return subsequentAngle;
//        }

//        private int numFinalBranches = 4;

//        private int numFinalBranchesVariation = 2;

//        private int numBranchesOffSplit = 3;

//        public  int NumTrunkBranchesOffSplit()
//        {
//            return numBranchesOffSplit;
//        }

//        private float numSegmentsInBranch = 3;

//        public  float NumSegmentsInBranch()
//        {
//            return numSegmentsInBranch;
//        }

//        //offset as percentage of segment length
//        private float segmentOffset = 0.4f;

//        public  float SegmentOffset()
//        {
//            return segmentOffset;
//        }

//        public  int NumFinalBranches()
//        {
//            return (int)this.GetValueFromVariation((float)numFinalBranches, (float)numFinalBranchesVariation);
//        }

//        private float lengthReductionFactor = 0.2f;

//        public  float LengthReductionFactor()
//        {
//            return lengthReductionFactor;
//        }

//        private float branchStartWidth = 0.1f;

//        public  float BranchStartWidth()
//        {
//            return branchStartWidth;
//        }

//        private float trunkStartWidth = 0.2f;
//        public float TrunkStartWidth()
//        {
//            return trunkStartWidth;
//        }

//        private float trunkTaperPercent = 0.5f;
//        public float TrunkTaperPercent()
//        {
//            return trunkTaperPercent;
//        }

//        private float minBranchWidth = 0.005f;

//        public  float MinBranchWidth()
//        {
//            return minBranchWidth;
//        }

//        private float taperPercent = 0.5f;

//        public  float TaperPercent()
//        {
//            return taperPercent;
//        }

//        public  int NumPointsOnLobe()
//        {
//            return numPointsOnLobe;
//        }

//        int numLeafPointsOnLobe = 30;
//        public int NumLeafPointsOnLobe()
//        {
//            return numLeafPointsOnLobe;
//        }

//        public  float Angle()
//        {
//            float a = GetValueFromVariation(angle, angleVariation);
//            return a;
//        }

//        //clamp on [value - variation : value + variation]
//        public float GetValueFromVariation(float value, float variation)
//        {
//            return value + ((float)game.rand.NextDouble() * (variation * 2)) - variation;
//        }

//        public void CreateLeaves(Game1 game, TreeBranch branch)
//        {
//            #region fix with better leaf code
//            float dist = Math.Abs((branch.end - branch.start).Length());
//            float leafDim = 0.175f;
//            //create leaf branches
//            if (branch.branchType != BranchType.Trunk)//!branch.isTrunk) //create new leaf branch and add leaves to that
//            {
//                for (float i = 0; i < dist; i += (leafDim * 1.5f))
//                {
//                    Vector3 lateral = Vector3.Cross(Vector3.Up, branch.Dir());
//                    lateral.Normalize();
//                    Quad leaf = new Quad(game, branch.start + branch.Dir() * i + lateral * (float)game.rand.NextDouble() * leafDim * 1.25f, Vector3.Up, branch.Dir(), leafDim, leafDim);
//                    ((Game1)game).leafQuads.Add(leaf);
//                    leaf = new Quad(game, branch.start + branch.Dir() * i + Vector3.Up * (float)game.rand.NextDouble() * leafDim * 1.25f, Vector3.Up, branch.Dir(), leafDim, leafDim);
//                    ((Game1)game).leafQuads.Add(leaf);


//                    leaf = new Quad(game, branch.start + branch.Dir() * i - lateral * (float)game.rand.NextDouble() * leafDim * 1.25f, Vector3.Up, branch.Dir(), leafDim, leafDim);
//                    ((Game1)game).leafQuads.Add(leaf);
//                    leaf = new Quad(game, branch.start + branch.Dir() * i - Vector3.Up * (float)game.rand.NextDouble() * leafDim * 1.25f, Vector3.Up, branch.Dir(), leafDim, leafDim);
//                    ((Game1)game).leafQuads.Add(leaf);

//                    //create direction
//                    int spread = 15;
//                    float xSpread = branch.ClampSpread(game.rand.Next(-spread, spread), 5);
//                    float ySpread = branch.ClampSpread(game.rand.Next(-spread, spread), 5);
//                    float zSpread = branch.ClampSpread(game.rand.Next(-spread, spread), 5);

//                    Vector3 origin = branch.start + branch.Dir() * i;
//                    Vector3 rotation = new Vector3(xSpread, ySpread, zSpread);
//                    Vector3 twigEnd = branch.RotateAroundPoint(origin + branch.Dir() * i, origin, rotation);
//                    //dir = twigEnd - origin;

//                    for (float j = 0; j < dist; j += leafDim * 1.5f)
//                    {
//                        lateral = Vector3.Cross(Vector3.Up, branch.Dir());
//                        lateral.Normalize();

//                        ((Game1)game).leafQuads.Add(new Quad(game, branch.start + branch.Dir() * i + (float)game.rand.NextDouble() * lateral * leafDim * 1.25f, Vector3.Up, branch.Dir(), leafDim, leafDim));
//                        ((Game1)game).leafQuads.Add(new Quad(game, branch.start + branch.Dir() * i - (float)game.rand.NextDouble() * lateral * leafDim * 1.25f, Vector3.Up, branch.Dir(), leafDim, leafDim));

//                        ((Game1)game).leafQuads.Add(new Quad(game, branch.start + branch.Dir() * i + (float)game.rand.NextDouble() * Vector3.Up * leafDim * 1.25f, Vector3.Up, branch.Dir(), leafDim, leafDim));
//                        ((Game1)game).leafQuads.Add(new Quad(game, branch.start + branch.Dir() * i - (float)game.rand.NextDouble() * Vector3.Up * leafDim * 1.25f, Vector3.Up, branch.Dir(), leafDim, leafDim));
//                    }
//                }
//            }
//            #endregion
//        }

//        public Texture2D LeafTexture()
//        {
//            return game.leafTexture;
//        }

//        public List<LeafLobe> CreateBranchControlPoints(List<LeafLobe> leafLobes)
//        {
//            foreach (LeafLobe lobe in leafLobes)
//            {
//                lobe.controlPoints = new List<BoundingSphere>();
//                for (int i = 0; i < NumPointsOnLobe(); i++)
//                {
//                    Vector3 point = game.GetRandomPointOnSphere(lobe.sphere);
//                    lobe.controlPoints.Add(new BoundingSphere(point, 0.1f));
//                }
//            }

//            return leafLobes;
//        }

//        public List<LeafLobe> CreateLeafControlPoints(List<LeafLobe> leafLobes)
//        {
//            foreach (LeafLobe lobe in leafLobes)
//            {
//                lobe.leafControlPoints = new List<BoundingSphere>();
//                for (int i = 0; i < NumLeafPointsOnLobe(); i++)
//                {
//                    Vector3 point = game.GetRandomPointOnSphere(lobe.sphere);
//                    lobe.leafControlPoints.Add(new BoundingSphere(point, 0.1f));
//                }
//            }

//            return leafLobes;
//        }

//        public Dictionary<LeafLobe, List<BoundingSphere>> GetBranchControlPoints()
//        {
//            return null;
//        }

//        public Dictionary<LeafLobe, List<BoundingSphere>> GetLeafControlPoints()
//        {
//            return null;
//        }

//        public void ConnectBranchesToLeafLobes()
//        {

//        }

//        public float TwigStartWidth()
//        {
//            return 0.05f;
//        }
//    }
//}
