﻿using System;
using System.Collections.Generic;
using System.Linq;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Media;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using kinectApp;
using System.Windows.Forms;

namespace mqpTestProject
{
    [TestClass]
    public class testTreeHierarchy
    {
        #region Additional test attributes
        //
        // You can use the following additional attributes as you write your tests:
        //
        // Use ClassInitialize to run code before running the first test in the class
        // [ClassInitialize()]
        // public static void MyClassInitialize(TestContext testContext) { }
        //
        // Use ClassCleanup to run code after all tests in a class have run
        // [ClassCleanup()]
        // public static void MyClassCleanup() { }
        //
        // Use TestInitialize to run code before running each test 
        // [TestInitialize()]
        // public void MyTestInitialize() { }
        //
        // Use TestCleanup to run code after each test has run
        // [TestCleanup()]
        // public void MyTestCleanup() { }
        //
        #endregion

        Game1 game;

        [TestInitialize()]
        public void MyTestInitialize() 
        {
            game = new Game1();
            MDIParent1 mainMDIForm = new MDIParent1(game);
            var gameWindow = Control.FromHandle(game.Window.Handle) as Form;
            gameWindow.ControlBox = false;
            if (gameWindow != null)
            {
                gameWindow.MdiParent = mainMDIForm;
                game.GameWindow = gameWindow;
            }
            mainMDIForm.Width = 827;
            mainMDIForm.Height = 621;

            game.parentForm = mainMDIForm;
            game.gameWindow = gameWindow;
        }

        TreeHierarchy treeHierarchy;

        [TestMethod]
        public void testHierarchy()
        {
            treeHierarchy = new TreeHierarchy(game);

            /*TreeBranch branch = new TreeBranch(Vector3.Zero, Vector3.Zero);
            TreeBranch child = new TreeBranch(Vector3.Zero, Vector3.Zero);
            TreeBranch child2 = new TreeBranch(Vector3.Zero, Vector3.Zero);
            TreeBranch gChild = new TreeBranch(Vector3.Zero, Vector3.Zero);
            
            child.AddChild(gChild);
            branch.AddChild(child);
            branch.AddChild(child2);

            treeHierarchy.AddBranch(branch);

            Assert.AreEqual(3, treeHierarchy.GetAllChildren(branch).Count);

            //treeHierarchy.RemoveBranch(1);
            //Assert.AreEqual(1, treeHierarchy.GetAllChildren(branch).Count);

            TreeBranch childCopy = child.Copy();
            Assert.AreEqual(1, treeHierarchy.GetAllChildren(child).Count);
            Assert.AreEqual(child.id, childCopy.id);*/
        }

        [TestMethod]
        public void TestNestedNodeID()
        {
            treeHierarchy = new TreeHierarchy(game);

            /*TreeBranch branch = new TreeBranch(Vector3.Zero, Vector3.Zero);
            TreeBranch child = new TreeBranch(Vector3.Zero, Vector3.Zero);

            branch.AddChild(child);

            treeHierarchy.AddBranch(branch);

            Assert.AreEqual(child, treeHierarchy.GetBranchById(child.id));*/
        }
    }
}
