using System;
using System.Windows.Forms;

namespace kinectApp
{
#if WINDOWS || XBOX
    static class Program
    {
        /// <summary>
        /// The main entry point for the application.
        /// </summary>
        [STAThread]
        static void Main(string[] args)
        {
            using (Game1 game = new Game1())
            {
                MDIParent1 mainMDIForm = new MDIParent1(game);
                var gameWindow = Control.FromHandle(game.Window.Handle) as Form;
                gameWindow.ControlBox = false;
                if (gameWindow != null)
                {
                    gameWindow.MdiParent = mainMDIForm;
                    game.GameWindow = gameWindow;
                }
                mainMDIForm.Width = 827;
                mainMDIForm.Height = 621;

                game.parentForm = mainMDIForm;
                game.gameWindow = gameWindow;

                mainMDIForm.Show();
                gameWindow.Show();
                game.Run();
            }
        }
    }
#endif
}

